/*
Velleman K8055 USB Experiment Interface Board library for BeOS/ZETA
Copyright (c) 2007 Gabriele Biffi
Version Beta 1 - 2007/02/09

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#ifndef _K8055_H
#define _K8055_H

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

// Open/close device
int OpenDevice(int cardAddress);
void CloseDevice(void);

// Analog channels
int ReadAnalogChannel(int channel);
void ReadAllAnalog(int *data1, int *data2);
void OutputAnalogChannel(int channel, int data);
void OutputAllAnalog(int data1, int data2);
void ClearAnalogChannel(int channel);
void ClearAllAnalog(void);
void SetAnalogChannel(int channel);
void SetAllAnalog(void);

// Digital channels
void WriteAllDigital(int data);
void ClearDigitalChannel(int channel);
void ClearAllDigital(void);
void SetDigitalChannel(int channel);
void SetAllDigital(void);
bool ReadDigitalChannel(int channel);
int ReadAllDigital(void);

// Counters
void ResetCounter(int counterNumber);
int ReadCounter(int counterNumber);
void SetCounterDebounceTime(int counterNumber, int debounceTime);

#ifdef __cplusplus
}
#endif // __cplusplus

#endif // _K8055_H
